using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;
using Silk.NET.SDL;
using Color = Jypeli.Color;

namespace KelaCombatTesti;

/// @author Sakari
/// @version 17.02.2025
/// <summary>
/// 
/// </summary>
    public class KelaCombatTesti : PhysicsGame
    {
        PlatformCharacter pelaaja;
        private Image KelabottiKuva = LoadImage("Kelabotti");
        private Image PelaajaKuva = LoadImage("Pelaaja.png");
      

        public override void Begin()
        {
            LuoKentta();
            LuoKelabotti();

            
            
            Keyboard.Listen(Key.A, ButtonState.Down, LiikuVasemmalle, null, new Vector());
            Keyboard.Listen(Key.D, ButtonState.Down, LiikuOikealle, null, new Vector());
            Keyboard.Listen(Key.W, ButtonState.Down, Hyppaa, null, new Vector());
            //Keyboard.Listen(Key.S, ButtonState.Down, LiikutaPelaajaa, null, new Vector(0, -1000));
            Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
            
            
        
            void LiikuVasemmalle(Vector vektori)
            {
                pelaaja.Walk(-100);
            }

            void LiikuOikealle(Vector vektori)
            {
                pelaaja.Walk(100);
            }
            
            void Hyppaa(Vector vektori)
            {
                pelaaja.Jump(300.0);
            }
        }

        void LuoKentta()
        {
         
            Level.BackgroundColor = Color.Pink;
            Gravity = new Vector(0, -981.0);
            
            PhysicsObject vasenReuna = Level.CreateLeftBorder();
            vasenReuna.Restitution = 0.0;
            vasenReuna.KineticFriction = 0.0;
            vasenReuna.IsVisible = false;

            PhysicsObject oikeaReuna = Level.CreateRightBorder();
            oikeaReuna.Restitution = 0.0;
            oikeaReuna.KineticFriction = 0.0;
            oikeaReuna.IsVisible = false;

            PhysicsObject ylaReuna = Level.CreateTopBorder();
            ylaReuna.Restitution = 0.0;
            ylaReuna.KineticFriction = 0.0;
            ylaReuna.IsVisible = false;

            PhysicsObject alaReuna = Level.CreateBottomBorder();
            alaReuna.Restitution = 1.0;
            alaReuna.IsVisible = false;
            alaReuna.KineticFriction = 0.0;

            pelaaja = LuoPelaaja(0.0, 0.0);
            pelaaja.Acceleration = new Vector(1, 0);

        }

        PlatformCharacter LuoPelaaja(double x, double y)
        {
            PlatformCharacter pelaaja = new PlatformCharacter(50.0, 100.0);
            pelaaja.Image = PelaajaKuva;
            pelaaja.Mass = 1.0;
            pelaaja.Image = LoadImage("Pelaaja.png");
            pelaaja.Shape = Shape.Rectangle;
            pelaaja.Color = Color.Black;
            pelaaja.X = x;
            pelaaja.Y = y;
            Add(pelaaja);
            


            return pelaaja;
        }

        PlatformCharacter LuoKelabotti()
        {
            PlatformCharacter Kelabotti = new PlatformCharacter(80.0, 80.0);
            Kelabotti.Color = Color.Orange;
            Kelabotti.Image = KelabottiKuva;
            Kelabotti.MirrorImage();
            Add(Kelabotti);
            
            
            FollowerBrain seuraajanAivot = new FollowerBrain(pelaaja);
            seuraajanAivot.Speed = 100;

            Kelabotti.Brain = seuraajanAivot;
            return Kelabotti;
            
        }
        
       
        
    }

        
    


